diff --git a/test/unit/daemon/status_report_test.rb b/test/unit/daemon/status_report_test.rb
new file mode 100644
index 00000000..103831a8
--- /dev/null
+++ b/test/unit/daemon/status_report_test.rb
@@ -0,0 +1,366 @@
+# frozen_string_literal: true
+
+require "test_helper"
+require "hive/daemon/status_report"
+require "hive/commands/daemon/service_installer"
+
+class DaemonStatusReportTest < Minitest::Test
+  include HiveTestHelper
+
+  FakeInstaller = Struct.new(
+    :service_state_hash, :expected, :installed, :parse_error,
+    keyword_init: true
+  ) do
+    def service_state = service_state_hash
+    def resolved_binary_for_status = expected
+    def installed_binary_path = installed
+    def binary_parse_error = parse_error
+  end
+
+  def report_for(dir, installer:, version_probe: ->(_b) { Hive::VERSION })
+    Hive::Daemon::StatusReport.new(
+      hive_home: dir,
+      installer: installer,
+      version_probe: version_probe,
+      update_state: nil
+    )
+  end
+
+  def make_bin(dir, name = "hive")
+    path = File.join(dir, "bin", name)
+    FileUtils.mkdir_p(File.dirname(path))
+    File.write(path, "#!/bin/sh\n")
+    FileUtils.chmod(0o755, path)
+    path
+  end
+
+  def test_matching_path_and_version_reports_none
+    with_tmp_dir do |dir|
+      hive = make_bin(dir)
+      installer = FakeInstaller.new(
+        service_state_hash: {
+          "platform" => "linux",
+          "unit_path" => "/u/hive-daemon.service",
+          "service_installed" => true,
+          "service_enabled" => true
+        },
+        expected: hive,
+        installed: hive,
+        parse_error: nil
+      )
+      payload = report_for(dir, installer: installer).to_h
+      assert_equal "none", payload["binary_drift"]
+      assert_equal hive, payload["expected_binary"]
+      assert_equal hive, payload["installed_binary"]
+      assert_equal Hive::VERSION, payload["installed_version"]
+      assert_equal Hive::VERSION, payload["current_version"]
+    end
+  end
+
+  def test_different_path_reports_path_drift
+    with_tmp_dir do |dir|
+      expected = make_bin(dir, "current-hive")
+      installed = make_bin(dir, "stale-hive")
+      installer = FakeInstaller.new(
+        service_state_hash: {
+          "platform" => "linux",
+          "unit_path" => "/u/hive-daemon.service",
+          "service_installed" => true,
+          "service_enabled" => true
+        },
+        expected: expected,
+        installed: installed,
+        parse_error: nil
+      )
+      payload = report_for(dir, installer: installer).to_h
+      assert_equal "path", payload["binary_drift"]
+    end
+  end
+
+  def test_same_path_different_version_reports_version_drift
+    with_tmp_dir do |dir|
+      hive = make_bin(dir)
+      installer = FakeInstaller.new(
+        service_state_hash: {
+          "platform" => "linux",
+          "unit_path" => "/u/hive-daemon.service",
+          "service_installed" => true,
+          "service_enabled" => true
+        },
+        expected: hive,
+        installed: hive,
+        parse_error: nil
+      )
+      payload = report_for(
+        dir,
+        installer: installer,
+        version_probe: ->(_b) { "0.0.1" }
+      ).to_h
+      assert_equal "version", payload["binary_drift"]
+      assert_equal "0.0.1", payload["installed_version"]
+    end
+  end
+
+  def test_unparseable_unit_reports_unparseable
+    with_tmp_dir do |dir|
+      installer = FakeInstaller.new(
+        service_state_hash: {
+          "platform" => "linux",
+          "unit_path" => "/u/hive-daemon.service",
+          "service_installed" => true,
+          "service_enabled" => false
+        },
+        expected: "/opt/hive",
+        installed: nil,
+        parse_error: "no ExecStart= line"
+      )
+      payload = report_for(dir, installer: installer).to_h
+      assert_equal "unparseable", payload["binary_drift"]
+    end
+  end
+
+  def test_missing_unit_reports_not_applicable
+    with_tmp_dir do |dir|
+      installer = FakeInstaller.new(
+        service_state_hash: {
+          "platform" => "linux",
+          "unit_path" => "/u/hive-daemon.service",
+          "service_installed" => false,
+          "service_enabled" => false
+        },
+        expected: "/opt/hive",
+        installed: nil,
+        parse_error: nil
+      )
+      payload = report_for(dir, installer: installer).to_h
+      assert_equal "not_applicable", payload["binary_drift"]
+    end
+  end
+
+  def test_probe_failure_reports_unreadable
+    with_tmp_dir do |dir|
+      bad = Object.new
+      def bad.service_state
+        raise "boom"
+      end
+      payload = report_for(dir, installer: bad).to_h
+      assert_equal "unreadable", payload["binary_drift"]
+      assert_nil payload["service_installed"]
+    end
+  end
+
+  def test_systemd_and_launchd_binary_parsing
+    with_tmp_dir do |dir|
+      hive = File.join(dir, "bin", "hive")
+      FileUtils.mkdir_p(File.dirname(hive))
+      File.write(hive, "#!/bin/sh\n")
+      FileUtils.chmod(0o755, hive)
+
+      linux = Hive::Commands::Daemon::ServiceInstaller.new(
+        host_os: "linux",
+        home: dir,
+        binary_path: hive,
+        systemctl_available: false,
+        runner: ->(*) { true }
+      )
+      linux.install!(autostart: false)
+      assert_equal hive, linux.installed_binary_path
+
+      # Escaped path with spaces
+      spaced = File.join(dir, "my hive", "hive")
+      FileUtils.mkdir_p(File.dirname(spaced))
+      File.write(spaced, "#!/bin/sh\n")
+      FileUtils.chmod(0o755, spaced)
+      linux2 = Hive::Commands::Daemon::ServiceInstaller.new(
+        host_os: "linux",
+        home: dir,
+        binary_path: spaced,
+        systemctl_available: false,
+        runner: ->(*) { true }
+      )
+      linux2.install!(autostart: false, force: true)
+      assert_equal spaced, linux2.installed_binary_path
+
+      mac = Hive::Commands::Daemon::ServiceInstaller.new(
+        host_os: "darwin",
+        home: dir,
+        binary_path: hive,
+        runner: ->(*) { true }
+      )
+      mac.install!(autostart: false)
+      assert_equal hive, mac.installed_binary_path
+    end
+  end
+
+  def test_version_probe_timeout_does_not_hang
+    with_tmp_dir do |dir|
+      hive = make_bin(dir)
+      installer = FakeInstaller.new(
+        service_state_hash: {
+          "platform" => "linux",
+          "unit_path" => "/u",
+          "service_installed" => true,
+          "service_enabled" => true
+        },
+        expected: hive,
+        installed: hive,
+        parse_error: nil
+      )
+      hung = lambda do |_binary|
+        raise Timeout::Error
+      end
+      payload = report_for(dir, installer: installer, version_probe: hung).to_h
+      assert_equal "unreadable", payload["binary_drift"]
+      assert_nil payload["installed_version"]
+    end
+  end
+
+  def test_default_version_probe_is_bounded_and_reports_timeout_as_unreadable
+    with_tmp_dir do |dir|
+      hive = File.join(dir, "bin", "hive")
+      FileUtils.mkdir_p(File.dirname(hive))
+      File.write(hive, "#!/bin/sh\nsleep 30\n")
+      FileUtils.chmod(0o755, hive)
+      installer = FakeInstaller.new(
+        service_state_hash: {
+          "platform" => "linux",
+          "unit_path" => "/u",
+          "service_installed" => true,
+          "service_enabled" => true
+        },
+        expected: hive,
+        installed: hive,
+        parse_error: nil
+      )
+      started = Process.clock_gettime(Process::CLOCK_MONOTONIC)
+
+      payload = Hive::Daemon::StatusReport.new(
+        hive_home: dir,
+        installer: installer,
+        update_state: nil
+      ).to_h
+
+      elapsed = Process.clock_gettime(Process::CLOCK_MONOTONIC) - started
+      assert_operator elapsed, :<, 5
+      assert_equal "unreadable", payload["binary_drift"]
+      assert_nil payload["installed_version"]
+    end
+  end
+
+  def test_default_version_probe_reports_nonzero_and_malformed_output_as_unreadable
+    with_tmp_dir do |dir|
+      scripts = {
+        "nonzero-hive" => "#!/bin/sh\necho 'hive 9.9.9'\nexit 1\n",
+        "malformed-hive" => "#!/bin/sh\necho 'unknown version'\n"
+      }
+      scripts.each do |name, body|
+        hive = File.join(dir, "bin", name)
+        FileUtils.mkdir_p(File.dirname(hive))
+        File.write(hive, body)
+        FileUtils.chmod(0o755, hive)
+        installer = FakeInstaller.new(
+          service_state_hash: {
+            "platform" => "linux",
+            "unit_path" => "/u",
+            "service_installed" => true,
+            "service_enabled" => true
+          },
+          expected: hive,
+          installed: hive,
+          parse_error: nil
+        )
+
+        payload = Hive::Daemon::StatusReport.new(
+          hive_home: dir,
+          installer: installer,
+          update_state: nil
+        ).to_h
+
+        assert_equal "unreadable", payload["binary_drift"], name
+        assert_nil payload["installed_version"], name
+      end
+    end
+  end
+
+  def test_nil_or_malformed_version_probe_result_reports_unreadable
+    with_tmp_dir do |dir|
+      hive = make_bin(dir)
+      installer = FakeInstaller.new(
+        service_state_hash: {
+          "platform" => "linux",
+          "unit_path" => "/u",
+          "service_installed" => true,
+          "service_enabled" => true
+        },
+        expected: hive,
+        installed: hive,
+        parse_error: nil
+      )
+
+      [ nil, "not-a-version" ].each do |probe_result|
+        payload = report_for(
+          dir,
+          installer: installer,
+          version_probe: ->(_binary) { probe_result }
+        ).to_h
+        assert_equal "unreadable", payload["binary_drift"]
+        assert_nil payload["installed_version"]
+      end
+    end
+  end
+
+  def test_reused_pid_is_not_reported_as_running
+    with_tmp_dir do |dir|
+      hive = make_bin(dir)
+      installer = FakeInstaller.new(
+        service_state_hash: {
+          "platform" => "linux",
+          "unit_path" => "/u",
+          "service_installed" => true,
+          "service_enabled" => true
+        },
+        expected: hive,
+        installed: hive,
+        parse_error: nil
+      )
+      File.write(
+        File.join(dir, ".daemon.pid"),
+        {
+          "pid" => Process.pid,
+          "process_start_time" => "definitely-not-this-process",
+          "started_at" => Time.now.utc.iso8601
+        }.to_yaml
+      )
+
+      payload = report_for(dir, installer: installer).to_h
+
+      assert_equal false, payload["running"]
+      assert_nil payload["pid"]
+    end
+  end
+
+  def test_schema_fields_present
+    with_tmp_dir do |dir|
+      installer = FakeInstaller.new(
+        service_state_hash: {
+          "platform" => "linux",
+          "unit_path" => nil,
+          "service_installed" => false,
+          "service_enabled" => false
+        },
+        expected: "/opt/hive",
+        installed: nil,
+        parse_error: nil
+      )
+      payload = report_for(dir, installer: installer).to_h
+      %w[
+        schema schema_version ok running pid uptime_sec pid_file log_file
+        service_installed service_enabled unit_path current_version update_nudge
+        expected_binary installed_binary installed_version binary_drift
+      ].each do |key|
+        assert payload.key?(key), "missing #{key}"
+      end
+      assert_includes Hive::Daemon::StatusReport::DRIFT_VALUES, payload["binary_drift"]
+    end
+  end
+end
diff --git a/test/unit/gemspec_test.rb b/test/unit/gemspec_test.rb
index a4ddfc6e..fe843721 100644
--- a/test/unit/gemspec_test.rb
+++ b/test/unit/gemspec_test.rb
@@ -25,9 +25,10 @@ class GemspecTest < Minitest::Test
     assert_includes spec.files, "bin/hv"
   end
 
-  # The web tier is a Rails app under web/, supported only in the Docker
-  # image or a source checkout — the gem must stay a lean CLI and not
-  # package the app or its old Sinatra-era assets.
+  # The web tier is a Rails app under web/. Local installs acquire a
+  # version-matched release archive (hive-web-<version>.tar.gz) via
+  # Hive::Web::AppBundle; the gem must stay a lean CLI and not package
+  # the app or its old Sinatra-era assets.
   def test_gem_package_excludes_the_rails_web_app
     spec = Gem::Specification.load(GEMSPEC_PATH)
 
@@ -36,4 +37,14 @@ class GemspecTest < Minitest::Test
     refute spec.files.any? { |f| f.start_with?("public/") },
            "no Sinatra-era static assets should be packaged"
   end
+
+  def test_web_release_archive_name_matches_app_bundle_contract
+    require "hive/web/app_bundle"
+    bundle = Hive::Web::AppBundle.new(version: Hive::VERSION)
+    assert_equal "hive-web-#{Hive::VERSION}.tar.gz", bundle.archive_basename
+    assert_match(
+      %r{\Ahttps://github.com/#{Regexp.escape(Hive::REPO_OWNER)}/#{Regexp.escape(Hive::REPO_NAME)}/releases/download/v#{Regexp.escape(Hive::VERSION)}/hive-web-#{Regexp.escape(Hive::VERSION)}\.tar\.gz\z},
+      bundle.release_asset_url
+    )
+  end
 end
diff --git a/test/unit/openclaw_skills_test.rb b/test/unit/openclaw_skills_test.rb
index eb700e97..37a0b21f 100644
--- a/test/unit/openclaw_skills_test.rb
+++ b/test/unit/openclaw_skills_test.rb
@@ -56,12 +56,28 @@ class OpenClawSkillsTest < Minitest::Test
     assert_includes body, "yay -S --noconfirm --needed hive-bin"
     assert_includes body, "v0.2.0/install.sh"
     assert_includes body, "daemon install"
-    assert_includes body, "init . --json </dev/null"
+    assert_includes body, '"${hive_cmd}" setup --json'
     assert_includes body, "slash-command text after `/hive` as arguments for `hive_cmd`"
     assert_includes body, '"${hive_cmd}" --help'
     assert_includes body, "Pass arguments safely"
   end
 
+  def test_guided_setup_delegates_provisioning_to_hive_setup
+    _metadata, body = read_skill("hive")
+    guided_setup = section(body, "## Guided Setup")
+
+    assert_includes guided_setup, '"${hive_cmd}" setup --json'
+    assert_includes guided_setup, "--service"
+    assert_includes guided_setup, "--no-init"
+    assert_includes guided_setup, "diagnostics"
+    assert_includes guided_setup, "qmd"
+    assert_includes guided_setup, "web bundle"
+    assert_includes guided_setup, "enrollment"
+    assert_includes guided_setup, "phases"
+    refute_includes guided_setup, '"${hive_cmd}" daemon install'
+    refute_includes guided_setup, '"${hive_cmd}" init . --json'
+  end
+
   def test_umbrella_skill_guards_destructive_and_blocking_commands
     _metadata, body = read_skill("hive")
 
diff --git a/test/unit/schema_files_test.rb b/test/unit/schema_files_test.rb
index 2d10237d..a5bc040c 100644
--- a/test/unit/schema_files_test.rb
+++ b/test/unit/schema_files_test.rb
@@ -12,10 +12,15 @@ require "hive/commands/prune"
 require "hive/commands/run"
 require "hive/commands/stage_action"
 require "hive/commands/status"
+require "hive/commands/setup"
+require "hive/commands/web"
+require "hive/commands/service_installer/outcome"
+require "hive/setup/diagnostics"
 require "hive/tui/snapshot"
 require "hive/daemon/dispatch_request_queue"
 require "hive/daemon/dispatch_result_queue"
 require "tmpdir"
+require "stringio"
 
 # Schema files under schemas/ are the published artefact for external
 # consumers (non-Ruby SDKs, CI validators, etc.). They must:
@@ -1476,6 +1481,7 @@ class SchemaFilesTest < Minitest::Test
     producer_required = %w[
       schema schema_version ok running pid uptime_sec pid_file log_file
       service_installed service_enabled unit_path current_version update_nudge
+      expected_binary installed_binary installed_version binary_drift
     ].sort
     assert_equal producer_required, schema_required,
                  "schema/producer required-key drift in hive-daemon-status.v1.json"
@@ -2063,6 +2069,83 @@ class SchemaFilesTest < Minitest::Test
            "schema must reject error_kind values outside the closed enum"
   end
 
+  # ── local setup / web lifecycle contracts ───────────────────────────────
+
+  def test_hive_setup_success_payload_validates_against_published_schema
+    result = Hive::Setup::Diagnostics::Result.new(
+      name: "ruby", status: "ok", detail: "ruby ok", fix: nil,
+      bootstrappable: false, path: "/usr/bin/ruby", version: "3.4.0"
+    )
+    report = Hive::Setup::Diagnostics::Report.new(
+      results: [ result ], platform: "linux", ok: true
+    )
+    diagnostics = Object.new
+    diagnostics.define_singleton_method(:call) { report }
+    output = StringIO.new
+
+    Dir.mktmpdir("hive-setup-schema") do |dir|
+      Hive::Commands::Setup.new(
+        project_path: dir, no_bootstrap: true, json: true,
+        binary_path: "/opt/hive/bin/hive", diagnostics: diagnostics,
+        output: output, err: StringIO.new
+      ).call
+    end
+
+    payload = JSON.parse(output.string)
+    schemer = JSONSchemer.schema(JSON.parse(File.read(Hive::Schemas.schema_path("hive-setup"))))
+    assert_empty schemer.validate(payload).to_a
+  end
+
+  def test_hive_web_status_active_and_inactive_payloads_validate
+    schemer = JSONSchemer.schema(JSON.parse(File.read(Hive::Schemas.schema_path("hive-web-status"))))
+
+    [ true, false ].each do |active|
+      installer = Object.new
+      installer.define_singleton_method(:status_snapshot) do
+        {
+          "platform" => "linux", "service_installed" => true,
+          "service_enabled" => true, "service_active" => active,
+          "unit_path" => "/tmp/hive-web.service"
+        }
+      end
+      command = Hive::Commands::Web.new(subcommand: "status", json: true)
+      command.define_singleton_method(:service_installer) { installer }
+      output, = capture_io do
+        begin
+          command.call
+        rescue Hive::Error
+          nil
+        end
+      end
+      payload = JSON.parse(output)
+      assert_empty schemer.validate(payload).to_a, "invalid active=#{active} payload: #{payload.inspect}"
+    end
+  end
+
+  def test_hive_web_install_success_and_failure_payloads_validate
+    schemer = JSONSchemer.schema(JSON.parse(File.read(Hive::Schemas.schema_path("hive-web-install"))))
+    installer = Struct.new(:messages) do
+      def envelope_platform = "linux"
+      def target_path = "/tmp/hive-web.service"
+    end.new([])
+
+    success = Hive::Commands::ServiceInstaller::Outcome.new(:written)
+    command = Hive::Commands::Web.new(json: true)
+    output, = capture_io { command.send(:emit_install_outcome, installer, success) }
+    assert_empty schemer.validate(JSON.parse(output)).to_a
+
+    installer.messages << "unit drifted"
+    failure = Hive::Commands::ServiceInstaller::Outcome.new(:drifted)
+    output, = capture_io do
+      begin
+        command.send(:emit_install_outcome, installer, failure)
+      rescue Hive::Error
+        nil
+      end
+    end
+    assert_empty schemer.validate(JSON.parse(output)).to_a
+  end
+
   # ── schema metadata identity ─────────────────────────────────────────────
 
   # Copy-pasting vN.json to vN+1.json and only changing the version const is
